<template>
  <div class="q-pa-md">
    <div class="q-gutter-y-md" style="max-width: 600px">
      <SettingsComponent />
      <q-card>
        <q-tabs
          v-model="tab"
          dense
          class="text-grey"
          active-color="primary"
          indicator-color="primary"
          align="justify"
          narrow-indicator
        >
          <q-tab
            @click="
              () => {
                getPersons();
              }
            "
            name="nearby"
            label="Najbliżsi"
          />
          <q-tab
            @click="
              () => {
                getPersons('all');
              }
            "
            name="all"
            label="Wszyscy"
          />
        </q-tabs>

        <q-separator />

        <q-tab-panels v-model="tab" animated>
          <q-tab-panel class="panel" name="nearby">
            <PersonComponent
              class="person"
              v-for="(person, index) in persons"
              :key="index"
              :data="person"
              menu="search"
            />
          </q-tab-panel>

          <q-tab-panel class="panel" name="all">
            <PersonComponent
              class="person"
              v-for="(person, index) in persons"
              :key="index"
              :data="person"
              menu="search"
            />
          </q-tab-panel>
        </q-tab-panels>
      </q-card>
    </div>
  </div>
</template>

<script lang="ts" setup>
import { ref } from 'vue';
import { api } from '../boot/axios';
import { useUserStore } from '../stores/user';

import SettingsComponent from 'src/components/SettingsComponent.vue';
import PersonComponent from '../components/PersonComponent.vue';

const store = useUserStore();
const { user } = store;

const tab = ref('nearby');
const persons = ref<
  Array<{
    nick: string;
    age: number;
    image: string;
    lazyImage: string;
    city: string;
    loggedIn: boolean;
  }>
>([]);

getPersons();
function getPersons(mode?: string) {
  let url = '/user/close-friends';

  if (mode === 'all') {
    url = '/user/close-friends-sorted';
  }
  api
    .get(url, {
      params: { uuid: user.uuid },
    })
    .then(({ data }) => {
      persons.value = data.map(
        (person: {
          nick: string;
          age: number;
          photos: string;
          name: string;
          loggedIn: boolean;
        }) => {
          const parsedPhotos = JSON.parse(person.photos);
          return {
            nick: person.nick,
            age: person.age,
            image: parsedPhotos.profile,
            lazyImage: parsedPhotos.profile,
            city: person.name,
            loggedIn: person.loggedIn,
          };
        }
      );
    })
    .catch((err) => {
      console.error(err);
    });
}

// Call getPersons function initially or based on some condition
getPersons(tab.value);
</script>
<style scoped>
.person {
  width: 200px;
  height: auto;
  margin: 20px;
}
.panel {
  display: flex;
  justify-content: center;
}
</style>
